(function () { "use strict";
function $extend(from, fields) {
	function inherit() {}; inherit.prototype = from; var proto = new inherit();
	for (var name in fields) proto[name] = fields[name];
	if( fields.toString !== Object.prototype.toString ) proto.toString = fields.toString;
	return proto;
}
var Main = function() { }
Main._ = function(str) {
	return $(str);
}
Main.main = function() {
	js.Browser.window.onload = Main._init;
}
Main._init = function(e) {
	Main._navigation = new display.navigation.Navigation($("#nav"));
	Main._scenes = new display.scenes.Scenes($("#scenes"));
	Main.changeSceneEvent(logic.Const.ID_SCENE_01);
}
Main.changeSceneEvent = function(id) {
	Main._navigation.changeScene(id);
	Main._scenes.changeScene(id);
}
var lib = {}
lib.button = {}
lib.button.IButton = function() { }
lib.button.BaseButton = function(id,target) {
	this._isCurrent = false;
	this._isActive = false;
	this._id = id;
	this._target = target;
	this._target.css({ cursor : "default"});
	this._target.bind("click",$bind(this,this._onClick));
};
lib.button.BaseButton.__interfaces__ = [lib.button.IButton];
lib.button.BaseButton._ = function(str) {
	return $(str);
}
lib.button.BaseButton.prototype = {
	_onClick: function(e) {
		e.preventDefault();
		if(this._isActive) console.log("_onClick : " + this._id);
	}
	,_onOut: function(e) {
		if(!this._isCurrent) this._target.removeClass("over");
	}
	,_onOver: function(e) {
		if(!this._isCurrent) this._target.addClass("over");
	}
	,deleteCurrent: function() {
		if(!this._isCurrent) return;
		this._isCurrent = false;
		this._target.removeClass("current");
		this._target.removeClass("over");
	}
	,setCurrent: function() {
		if(this._isCurrent) return;
		this._isCurrent = true;
		this._target.addClass("current");
		this._target.removeClass("over");
	}
	,deleteActive: function() {
		if(!this._isActive) return;
		this._isActive = false;
		this._target.css({ cursor : "default"});
		this._target.unbind("mouseenter",$bind(this,this._onOver));
		this._target.unbind("mouseleave",$bind(this,this._onOut));
	}
	,setActive: function() {
		if(this._isActive) return;
		this._isActive = true;
		this._target.css({ cursor : "pointer"});
		this._target.bind("mouseenter",$bind(this,this._onOver));
		this._target.bind("mouseleave",$bind(this,this._onOut));
	}
	,getId: function() {
		return this._id;
	}
}
var display = {}
display.navigation = {}
display.navigation.Button = function(id,target) {
	lib.button.BaseButton.call(this,id,target);
};
display.navigation.Button.__interfaces__ = [lib.button.IButton];
display.navigation.Button._ = function(str) {
	return $(str);
}
display.navigation.Button.__super__ = lib.button.BaseButton;
display.navigation.Button.prototype = $extend(lib.button.BaseButton.prototype,{
	_onClick: function(e) {
		e.preventDefault();
		if(this._isActive) Main.changeSceneEvent(this._id);
	}
});
display.navigation.Navigation = function(target) {
	this._collections = new Array();
	this._target = target;
	var btn01 = this._target.find("#btn01");
	var btn01Id = btn01.attr("data-id");
	this._btn01 = new display.navigation.Button(btn01Id,btn01);
	this._collections.push(new logic.Collection(btn01Id,this._btn01));
	var btn02 = this._target.find("#btn02");
	var btn02Id = btn02.attr("data-id");
	this._btn02 = new display.navigation.Button(btn02Id,btn02);
	this._collections.push(new logic.Collection(btn02Id,this._btn02));
	var btn03 = this._target.find("#btn03");
	var btn03Id = btn03.attr("data-id");
	this._btn03 = new display.navigation.Button(btn03Id,btn03);
	this._collections.push(new logic.Collection(btn03Id,this._btn03));
};
display.navigation.Navigation._ = function(str) {
	return $(str);
}
display.navigation.Navigation.prototype = {
	changeScene: function(id) {
		var _g = 0, _g1 = this._collections;
		while(_g < _g1.length) {
			var i = _g1[_g];
			++_g;
			var target = i.getTarget();
			if(i.getId() == id) {
				target.deleteActive();
				target.setCurrent();
			} else {
				target.setActive();
				target.deleteCurrent();
			}
		}
	}
}
lib.display = {}
lib.display.IDisplay = function() { }
lib.display.BaseDisplay = function(id,target) {
	this._isOpen = false;
	this._id = id;
	this._target = target;
	this._target.css({ display : "none"});
};
lib.display.BaseDisplay.__interfaces__ = [lib.display.IDisplay];
lib.display.BaseDisplay._ = function(str) {
	return $(str);
}
lib.display.BaseDisplay.prototype = {
	_completeClose: function() {
	}
	,_onClose: function() {
		this._target.css({ display : "none"});
		this._completeClose();
	}
	,close: function() {
		if(!this._isOpen) return;
		this._isOpen = false;
		this._onClose();
	}
	,_completeOpen: function() {
	}
	,_onOpen: function() {
		this._target.css({ display : "block"});
		this._completeOpen();
	}
	,open: function() {
		if(this._isOpen) return;
		this._isOpen = true;
		this._onOpen();
	}
	,getId: function() {
		return this._id;
	}
}
display.scenes = {}
display.scenes.Scene = function(id,target) {
	lib.display.BaseDisplay.call(this,id,target);
};
display.scenes.Scene.__interfaces__ = [lib.display.IDisplay];
display.scenes.Scene._ = function(str) {
	return $(str);
}
display.scenes.Scene.__super__ = lib.display.BaseDisplay;
display.scenes.Scene.prototype = $extend(lib.display.BaseDisplay.prototype,{
});
display.scenes.Scenes = function(target) {
	this._collections = new Array();
	this._target = target;
	var scene01 = this._target.find("#scene01");
	var scene01Id = scene01.attr("data-id");
	this._scene01 = new display.scenes.Scene(scene01Id,scene01);
	this._collections.push(new logic.Collection(scene01Id,this._scene01));
	var scene02 = this._target.find("#scene02");
	var scene02Id = scene02.attr("data-id");
	this._scene02 = new display.scenes.Scene(scene02Id,scene02);
	this._collections.push(new logic.Collection(scene02Id,this._scene02));
	var scene03 = this._target.find("#scene03");
	var scene03Id = scene03.attr("data-id");
	this._scene03 = new display.scenes.Scene(scene03Id,scene03);
	this._collections.push(new logic.Collection(scene03Id,this._scene03));
};
display.scenes.Scenes._ = function(str) {
	return $(str);
}
display.scenes.Scenes.prototype = {
	changeScene: function(id) {
		var _g = 0, _g1 = this._collections;
		while(_g < _g1.length) {
			var i = _g1[_g];
			++_g;
			var target = i.getTarget();
			if(i.getId() == id) target.open(); else target.close();
		}
	}
}
var js = {}
js.Browser = function() { }
var logic = {}
logic.Collection = function(id,target) {
	this._id = id;
	this._target = target;
};
logic.Collection.prototype = {
	getTarget: function() {
		return this._target;
	}
	,getId: function() {
		return this._id;
	}
}
logic.Const = function() { }
var $_, $fid = 0;
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $fid++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = function(){ return f.method.apply(f.scope, arguments); }; f.scope = o; f.method = m; o.hx__closures__[m.__id__] = f; } return f; };
var q = window.jQuery;
js.JQuery = q;
js.Browser.window = typeof window != "undefined" ? window : null;
logic.Const.ID_SCENE_01 = "scene01";
logic.Const.ID_SCENE_02 = "scene02";
logic.Const.ID_SCENE_03 = "scene03";
Main.main();
})();
