package display.navigation;

import js.Browser;
import js.JQuery;
import display.navigation.Button;
import lib.button.IButton;
import logic.Collection;

/**
 * ...
 * @author Nishida Shingo
 */
class Navigation {

	static inline function _(str:String):JQuery {return untyped $(str);}
	private var _target:JQuery;
	private var _btn01:Button;
	private var _btn02:Button;
	private var _btn03:Button;
	private var _collections:Array<Collection>;

	public function new(target:JQuery) {
		this._collections = new Array();
		this._target = target;
		//
		var btn01:JQuery = this._target.find("#btn01");
		var btn01Id:String = btn01.attr("data-id");
		this._btn01 = new Button(btn01Id, btn01);
		this._collections.push(new Collection(btn01Id, this._btn01));
		//
		var btn02:JQuery = this._target.find("#btn02");
		var btn02Id:String = btn02.attr("data-id");
		this._btn02 = new Button(btn02Id, btn02);
		this._collections.push(new Collection(btn02Id, this._btn02));
		//
		var btn03:JQuery = this._target.find("#btn03");
		var btn03Id:String = btn03.attr("data-id");
		this._btn03 = new Button(btn03Id, btn03);
		this._collections.push(new Collection(btn03Id, this._btn03));
	}
	
	public function changeScene(id:String) :Void {
		for (i in this._collections) {
			var target:IButton = i.getTarget(); 
			if (i.getId() == id) {
				target.deleteActive();
				target.setCurrent();
			} else {
				target.setActive();
				target.deleteCurrent();
			}
		}
	}
	
}