package display.scenes;

import js.Browser;
import js.JQuery;
import display.scenes.Scene;
import lib.display.IDisplay;
import logic.Collection;

/**
 * ...
 * @author Nishida Shingo
 */
class Scenes {

	static inline function _(str:String):JQuery {return untyped $(str);}
	private var _target:JQuery;
	private var _scene01:Scene;
	private var _scene02:Scene;
	private var _scene03:Scene;
	private var _collections:Array<Collection>;

	public function new(target:JQuery) {
		this._collections = new Array();
		this._target = target;
		//
		var scene01:JQuery = this._target.find("#scene01");
		var scene01Id:String = scene01.attr("data-id");
		this._scene01 = new Scene(scene01Id, scene01);
		this._collections.push(new Collection(scene01Id, this._scene01));
		//
		var scene02:JQuery = this._target.find("#scene02");
		var scene02Id:String = scene02.attr("data-id");
		this._scene02 = new Scene(scene02Id, scene02);
		this._collections.push(new Collection(scene02Id, this._scene02));
		//
		var scene03:JQuery = this._target.find("#scene03");
		var scene03Id:String = scene03.attr("data-id");
		this._scene03 = new Scene(scene03Id, scene03);
		this._collections.push(new Collection(scene03Id, this._scene03));
	}
	
	public function changeScene(id:String) :Void {
		for (i in this._collections) {
			var target:IDisplay = i.getTarget(); 
			if (i.getId() == id) {
				target.open();
			} else {
				target.close();
			}
		}
	}
	
}