package lib.button;

import js.Browser;
import js.JQuery;

/**
 * ...
 * @author Nishida Shingo
 */
class BaseButton implements IButton {
	
	static inline function _(str:String):JQuery {return untyped $(str);}
	private var _target:JQuery;
	private var _id:String;
	private var _isActive:Bool = false;
	private var _isCurrent:Bool = false;

	public function new(id:String, target:JQuery) {
		this._id = id;
		this._target = target;
		this._target.css({cursor: "default"});
		this._target.bind("click", this._onClick);
	}
	
	public function getId() :String {
		return this._id;
	}
	
	public function setActive() :Void {
		if (this._isActive) {
			return;
		}
		this._isActive = true;
		this._target.css({cursor: "pointer"});
		this._target.bind("mouseenter", this._onOver);
		this._target.bind("mouseleave", this._onOut);
	}
	
	public function deleteActive() :Void {
		if (!this._isActive) {
			return;
		}
		this._isActive = false;
		this._target.css({cursor: "default"});
		this._target.unbind("mouseenter", this._onOver);
		this._target.unbind("mouseleave", this._onOut);
	}
	
	public function setCurrent() :Void {
		if (this._isCurrent) {
			return;
		}
		this._isCurrent = true;
		this._target.addClass("current");
		this._target.removeClass("over");
	}
	
	public function deleteCurrent() :Void {
		if (!this._isCurrent) {
			return;
		}
		this._isCurrent = false;
		this._target.removeClass("current");
		this._target.removeClass("over");
	}
	
	private function _onOver(e:JqEvent) :Void {
		if (!this._isCurrent) {
			this._target.addClass("over");
		}
	}
	
	private function _onOut(e:JqEvent) :Void {
		if (!this._isCurrent) {
			this._target.removeClass("over");
		}
	}
	
	private function _onClick(e:JqEvent):Void {
		e.preventDefault();
		if (this._isActive) {
			trace("_onClick : " + this._id);
			//Browser.window.alert("_onClick : " + this._id);
		}
	}
	
}