package lib.display;

import js.Browser;
import js.JQuery;

/**
 * ...
 * @author Nishida Shingo
 */
class BaseDisplay implements IDisplay {
	
	static inline function _(str:String):JQuery {return untyped $(str);}
	private var _target:JQuery;
	private var _id:String;
	private var _isOpen:Bool = false;

	public function new(id:String, target:JQuery) {
		this._id = id;
		this._target = target;
		this._target.css({display: "none"});
	}
	
	public function getId() :String {
		return this._id;
	}
	
	public function open() :Void {
		if (this._isOpen) {
			return;
		}
		this._isOpen = true;
		this._onOpen();
	}
	
	private function _onOpen() :Void {
		this._target.css({display: "block"});
		this._completeOpen();
	}
	
	private function _completeOpen() :Void {
	}
	
	public function close() :Void {
		if (!this._isOpen) {
			return;
		}
		this._isOpen = false;
		this._onClose();
	}
	
	private function _onClose() :Void {
		this._target.css({display: "none"});
		this._completeClose();
	}
	
	private function _completeClose() :Void {
	}
	
}